require "parichki_bg/version"
require 'net/http'
require 'openssl'
require "base64"
require 'uri'
require 'active_support'
require 'json'


require "parichki_bg/request/base"
require "parichki_bg/request/query"
require "parichki_bg/request/transaction"
require "parichki_bg/railtie" if defined? Rails

module ParichkiBg

  class << self


    def vendor_id
      @@vendor_id
    end

    def secret_key
      @@secret_key
    end

    def vendor_id=(vendor_id)
      @@vendor_id = vendor_id
    end

    def secret_key=(secret_key)
      @@secret_key = secret_key
    end

    def main_api_url
      "https://api.dir.bg"
    end

    def hmac(string)
      OpenSSL::HMAC.hexdigest("sha256", secret_key, string)      
    end

  end

end