module ParichkiBg
  module Request
    class Base

      attr_reader :amount, :pin, :user_id

      def initialize(attributes = {})
        @amount = attributes.fetch :amount
        @pin = attributes.fetch :pin
        @user_id = attributes.fetch :user_id
      end

      def https
        @http ||= Net::HTTP.new uri.host, uri.port
        @http.use_ssl = true
        @http.verify_mode = OpenSSL::SSL::VERIFY_NONE
        @http
      end

      def send
        @response = https.get uri.request_uri
      end

      def signed_request
        encoded_checksum + "." + encoded_data
      end

      def checksum
        ParichkiBg.hmac to_json
      end

      def encoded_checksum
        Base64.strict_encode64 checksum
      end

      def encoded_data
        Base64.strict_encode64 to_json
      end

      def result
        if success?
          ActiveSupport::JSON.decode @response.body
        else
          {"error" => "UserNotFound"}
        end
      end
    end

  end
end