module ParichkiBg
  module Request
    class Transaction < ParichkiBg::Request::Base

      attr_reader :request_id
      attr_accessor :type

      def initialize(attributes = {})
        super
        @request_id = attributes.fetch :request_id
      end

      def uri
        URI "#{ParichkiBg::main_api_url}/#{user_id}/transactions?vendor_id=#{ParichkiBg::vendor_id}&signed_request=#{signed_request}"
      end

      def to_json
        {
          amount:     amount.to_s,
          request_id: request_id.to_s,
          type:       type,
          pin:        pin
        }.to_json
      end

      def pay_with_cash
        @type = "cash"
        send
      end

      def pay_with_points
        @type = "points"
        send
      end

      def success?
        @response.code == "200" && !@response.body.match(/error/)
      end

      def paid?
        result["error"].nil? 
      end

    end
  end
end